rule_files:
  - ../rules.d/tpa_hoster.rules

evaluation_interval: 1m

tests:
  - interval: 1m
    input_series:
      # hoster quintex is mostly failing, firing
      - series: 'probe_success{alias="anonticket-01.torproject.org",hoster="quintex",instance="localhost:9115",job="blackbox_http_3xx",target="http://anonticket.torproject.org/",team="TPA"}'
        values: '0x15'
      - series: 'probe_success{alias="btcpayserver-02.torproject.org",hoster="quintex",instance="localhost:9115",job="blackbox_http_3xx",target="http://btcpayserver-02.torproject.org/",team="TPA"}'
        values: '0x15'
      - series: 'probe_success{alias="btcpayserver-01.torproject.org",hoster="quintex",instance="localhost:9115",job="blackbox_http_3xx",target="http://btcpayserver-01.torproject.org/",team="TPA"}'
        values: '1x15'
      # probes mostly failing but there's no hoster label, not firing
      - series: 'probe_success{alias="host-01.torproject.org",instance="localhost:9115",job="blackbox_http_3xx",target="http://host-01.torproject.org/",team="TPA"}'
        values: '0x15'
      - series: 'probe_success{alias="host-02.torproject.org",instance="localhost:9115",job="blackbox_http_3xx",target="http://host-02.torproject.org/",team="TPA"}'
        values: '0x15'
      - series: 'probe_success{alias="host-03.torproject.org",instance="localhost:9115",job="blackbox_http_3xx",target="http://host-03.torproject.org/",team="TPA"}'
        values: '1x15'
      # hoster onionhosting is mostly failing, but only for a small period, not firing
      - series: 'probe_success{alias="onions-01.torproject.org",hoster="onionhosting",instance="localhost:9115",job="blackbox_http_3xx",target="http://onions-01.torproject.org/",team="TPA"}'
        values: '0x5 1x10'
      - series: 'probe_success{alias="onions-02.torproject.org",hoster="onionhosting",instance="localhost:9115",job="blackbox_http_3xx",target="http://onions-02.torproject.org/",team="TPA"}'
        values: '0x5 1x10'
      - series: 'probe_success{alias="onions-03.torproject.org",hoster="onionhosting",instance="localhost:9115",job="blackbox_http_3xx",target="http://onions-03.torproject.org/",team="TPA"}'
        values: '1x15'
      # hoster hetzner-nbg1 is failing but not enough for problems, not firing
      - series: 'probe_success{alias="hetzner-nbg1-02.torproject.org",hoster="hetzner-nbg1",instance="localhost:9115",job="blackbox_http_3xx",target="http://alertmanager2.torproject.org/",team="TPA"}'
        values: '1x15'
      - series: 'probe_success{alias="hetzner-nbg1-01.torproject.org",hoster="hetzner-nbg1",instance="localhost:9115",job="blackbox_http_3xx",target="http://alertmanager1.torproject.org/",team="TPA"}'
        values: '0x15'
      # hoster hetzner-dc13 is all successful, not firing
      - series: 'probe_success{alias="alberti.torproject.org",hoster="hetzner-dc13",instance="localhost:9115",job="blackbox_ssh_banner",target="alberti.torproject.org:22",team="TPA"}'
        values: '1x15'
      - series: 'probe_success{alias="chives.torproject.org",hoster="hetzner-dc13",instance="localhost:9115",job="blackbox_http_3xx",target="http://kgb-bot.torproject.org/",team="TPA"}'
        values: '1x15'
    alert_rule_test:
      - eval_time: 15m
        alertname: EntireHosterDown
        exp_alerts:
          - exp_labels:
              severity: warning
              team: TPA
              hoster: quintex
            exp_annotations:
              summary: 'All probes towards hoster quintex are failing'
              description: "We're seeing at least 90% of all probes towards host at quintex fail. There might be a global outage or network issues"
              playbook: 'TODO'
